Bug 1119320 - Zero-minimum possessive groups does not match empty string in
Summary: Zero-minimum possessive groups does not match empty string in
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: pcre
Version: 7.1
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Petr Pisar
QA Contact: Jan Kepler
URL: http://bugs.exim.org/show_bug.cgi?id=...
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-07-14 13:53 UTC by Petr Pisar
Modified: 2015-11-19 05:15 UTC (History)
5 users (show)

Fixed In Version: pcre-8.32-15.el7
Doc Type: Bug Fix
Doc Text:
A bug in PCRE was causing it to match the wrong substring in regular expressions with empty-matching possessive zero-repeat groups. This problem has been fixed and matching these groups now behaves as expected.
Clone Of: 1119241
Environment:
Last Closed: 2015-11-19 05:15:01 UTC


Attachments (Terms of Use)
Upstream patch ported to 8.33 (6.01 KB, patch)
2014-07-14 13:54 UTC, Petr Pisar
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2015:2142 normal SHIPPED_LIVE pcre bug fix update 2015-11-19 08:16:47 UTC

Description Petr Pisar 2014-07-14 13:53:45 UTC
+++ This bug was initially created as a clone of Bug #1119241 +++

The JIT mode and Perl matches like this:

$ printf '%s\n%s\n' '/\A(?:[^"]++|"(?:[^"]*+|"")*+")++/' 'NON QUOTED "QUOT""ED" AFTER "NOT MATCHED' | pcretest -s++
PCRE version 8.33 2013-05-28

  re> data>  0: NON QUOTED "QUOT""ED" AFTER  (JIT)
data> 

While the interpreter mode does not:

$ printf '%s\n%s\n' '/\A(?:[^"]++|"(?:[^"]*+|"")*+")++/' 'NON QUOTED "QUOT""ED" AFTER "NOT MATCHED' | pcretest 
PCRE version 8.33 2013-05-28

  re> data>  0: NON QUOTED 
data> 

this is fixed with upstream commit:

commit d27238d61fdbd404b2caa5eac9332cdf76a604fc
Author: ph10 <ph10@2f5784b3-3f2a-0410-8824-cb99058d5e15>
Date:   Tue May 27 13:18:31 2014 +0000

    Fix empty-matching possessive zero-repeat groups bug.
    
    
    git-svn-id: svn://vcs.exim.org/pcre/code/trunk@1478 2f5784b3-3f2a-0410-8824-cb99058d5e15

All Fedoras are affected.
----

RHEL-7 is affected (pcre-8.32-12.el7.x86_64).

Comment 1 Petr Pisar 2014-07-14 13:54:35 UTC
Created attachment 917875 [details]
Upstream patch ported to 8.33

Comment 9 errata-xmlrpc 2015-11-19 05:15:01 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHBA-2015-2142.html


Note You need to log in before you can comment on or make changes to this bug.